;;; Implementation of the library in Scheme

;; Setup of exports
(foreign-declare
	"#define _CFOO_IMPL_"
	"#include \"cfoo.h\"")

;; Automatic library initialization
(foreign-declare
	"__attribute__((constructor)) void cfoo_init(void) {"
	"	CHICKEN_run((void *)C_toplevel);"
	"}")

;; Implementation of the cfoo_say_hello function
(define-external (cfoo_say_hello [c-string name]) void
	(print "Hello " (or name "world")))

(return-to-host)
